package main

import (
	"encoding/json"
	"fmt"
	"log"
	"time"

	"github.com/474420502/focus/tree/heap"
	"github.com/gin-gonic/gin"
)

var tagCounter = make(map[string]*tagcounter)

type taginfo struct {
	Name  string
	Value int
}

type tagcounter struct {
	Name      string
	LastTime  time.Time
	CountWord map[string]*taginfo
	PQueue    []interface{}
}

func init() {

}

func CountTag(cxt *gin.Context) {
	platform := cxt.Query("platform")
	var cw *tagcounter
	if cw, ok := tagCounter[platform]; ok {
		if time.Now().Sub(cw.LastTime).Minutes() <= 10 {
			cxt.JSON(200, cw.PQueue)
			return
		}
	}

	sql := fmt.Sprintf(SqlTag, platform)
	rows, err := StoreStreamer.Query(sql)
	if err != nil {
		cxt.Error(err)
		return
	}

	cw = &tagcounter{}
	cw.CountWord = make(map[string]*taginfo)
	cw.Name = platform
	cw.LastTime = time.Now()
	tagCounter[platform] = cw

	for rows.Next() {
		var stag string
		err = rows.Scan(&stag)
		if err != nil {
			log.Println(err)
		}
		var tag []string
		json.Unmarshal([]byte(stag), &tag)
		for _, t := range tag {
			if _, ok := cw.CountWord[t]; ok {
				cw.CountWord[t].Value++
			} else {
				cw.CountWord[t] = &taginfo{Name: t, Value: 1}
			}
		}
	}

	heap := heap.New(func(a, b interface{}) int {
		if a.(*taginfo).Value >= b.(*taginfo).Value {
			return 1
		}
		return -1

	})

	var other = &taginfo{Name: "Other...", Value: 0}
	var i = 0
	for _, v := range cw.CountWord {
		if i <= 99 {
			heap.Put(v)
		} else {
			break
		}
		i++
	}

	// heap.Put(other)
	cw.PQueue = heap.Values()
	other.Value = cw.PQueue[len(cw.PQueue)-1].(*taginfo).Value - 1
	if other.Value == 0 {
		other.Value = 1
	}

	cw.PQueue = append(cw.PQueue, other)
	cxt.JSON(200, cw.PQueue)
	cw.LastTime = time.Now()
}
